
import 'dart:html';
import 'package:fields/fields.dart';

main() {
  fieldsTheme = const DarkFieldsTheme();
  var editor = 
      new ObjectEditor()
          ..selected = new KitchenSink();  
  document.body.append(editor.element);
}

class KitchenSink {
  @UseFieldEditor(ColorEditor)
  String color = '#00a000';
  @DisplayName('now')
  DateTime date = new DateTime.now();
  final List<int> integers = [1, 2, 3, 4];
  final Map map = { 'a' : 1, 'b' : 2 };
  Simple simple = new Simple();  
}

class Simple {
  @ReadOnly
  bool _boolean = false;
  bool
    get boolean => _boolean;
    set boolean(bool b) => _boolean = b;
  
  @IgnoreField
  int _integer = 42;
  @UseRange(min: 40, max:50)
  @UseFieldEditor(RangeEditor)
  int 
    get integer => _integer;
    set integer(int i) => _integer = i;
    
  double _float = 3.14;
  double
    get float => _float;
    set float(double d) => _float = d;
    
  num _number = 12.3;
  @UseRange(min: 12, max: 14, step:0.1)
  num
    get number => _number;
    set number(num n) => _number = n;
    
  String _text = 'lorem ipsum';
  String
    get text => _text;
    set text(String t) => _text = t;
    
  String toString() => 'simple($boolean,$integer,$float,$number,$text)';
}
