library fields.default_transforms;

import 'field_transform.dart';

void registerDefaultFieldTransforms() {  
  FieldTransform.register(const _IntToNumTransform());
  FieldTransform.register(const _NumToIntTransform());
  FieldTransform.register(const _StringToIntTransform());
  FieldTransform.register(const _StringToDoubleTransform());
}

class _IntToNumTransform extends FieldTransform<int, num> {
  const _IntToNumTransform();
  call(value) => value;
}

class _NumToIntTransform extends FieldTransform<num, int> {
  const _NumToIntTransform();
  call(value) => value.toInt();
}

class _StringToIntTransform extends FieldTransform<String, int> {
  const _StringToIntTransform();
  call(value) {
    try {
      return int.parse(value);
    } on FormatException catch(e) {
      throw new FieldTransformError(cause: e);
    }
  }
}

class _StringToDoubleTransform extends FieldTransform<String, double> {
  const _StringToDoubleTransform();
  call(value) {
    try {
      return double.parse(value);      
    } on FormatException catch(e) {
      throw new FieldTransformError(cause: e);
    }
  }
}
