library fields.theme;

FieldsTheme _theme = const FieldsTheme(); 
FieldsTheme 
  get fieldsTheme => _theme;
  set fieldsTheme(FieldsTheme theme) => _theme = theme;

// -----------------------------------------------------------------------------
// Default
// -----------------------------------------------------------------------------
  
class FieldsTheme {
  final FieldsColors colors = const FieldsColors();
  final FieldsImages images = const FieldsImages();
  const FieldsTheme();
}
  
class FieldsColors {
  final String background = 'transparent';
  final String border = 'grey';
  final String error = 'red';
  final String fieldBackground = 'transparent';
  final String text = 'black';
  final String textDisabled = 'grey';
  const FieldsColors();
}

class FieldsImages {
  final String down = 'packages/fields/res/down.png';
  final String up = 'packages/fields/res/up.png';
  final String lock = 'packages/fields/res/lock.png';  
  final String unlock = 'packages/fields/res/unlock.png';
  const FieldsImages();
}

// -----------------------------------------------------------------------------
// Dark
// -----------------------------------------------------------------------------

class DarkFieldsTheme extends FieldsTheme {
  final FieldsColors colors = const DarkFieldsColors();
  final FieldsImages images = const DarkFieldsImages();
  const DarkFieldsTheme();
}

class DarkFieldsColors extends FieldsColors {
  final String background = '#2d2d30';
  final String border = '#2d2d30';
  final String fieldBackground = '#252526';
  final String text = '#f1f1f1';
  const DarkFieldsColors();
}

class DarkFieldsImages extends FieldsImages {
  final String down = 'packages/fields/res/dark/down.png';
  final String up = 'packages/fields/res/dark/up.png';
  final String lock = 'packages/fields/res/dark/lock.png';  
  final String unlock = 'packages/fields/res/dark/unlock.png';
  const DarkFieldsImages();
}
